VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "NPort TCP Server Example"
   ClientHeight    =   7440
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5385
   LinkTopic       =   "Form1"
   ScaleHeight     =   7440
   ScaleWidth      =   5385
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCount 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   2052
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   2760
      MaxLength       =   2
      TabIndex        =   11
      Text            =   "1"
      Top             =   2040
      Width           =   735
   End
   Begin VB.CommandButton cmdDefaultData 
      Caption         =   "Send Default Pattern"
      Height          =   375
      Left            =   240
      TabIndex        =   9
      Top             =   2040
      Width           =   1815
   End
   Begin VB.TextBox txtRecv 
      Height          =   1815
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   8
      Top             =   5280
      Width           =   4815
   End
   Begin VB.TextBox txtSend 
      Height          =   1815
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   6
      Top             =   3000
      Width           =   4815
   End
   Begin VB.Timer Timer1 
      Left            =   3840
      Top             =   1920
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop Server"
      Height          =   375
      Left            =   3600
      TabIndex        =   2
      Top             =   1440
      Width           =   1335
   End
   Begin VB.TextBox txtPort 
      BeginProperty DataFormat 
         Type            =   1
         Format          =   "0"
         HaveTrueFalseNull=   0
         FirstDayOfWeek  =   0
         FirstWeekOfYear =   0
         LCID            =   1028
         SubFormatType   =   1
      EndProperty
      Height          =   375
      Left            =   2160
      MaxLength       =   4
      TabIndex        =   0
      Text            =   "4001"
      Top             =   1080
      Width           =   855
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start Server"
      Height          =   375
      Left            =   3600
      TabIndex        =   1
      Top             =   960
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Count"
      Height          =   255
      Left            =   2160
      TabIndex        =   10
      Top             =   2160
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Receive Data"
      Height          =   375
      Left            =   240
      TabIndex        =   7
      Top             =   5040
      Width           =   1215
   End
   Begin VB.Label S 
      Caption         =   "Send Data"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   2640
      Width           =   855
   End
   Begin VB.Label Label3 
      Caption         =   "NPort TCP Server will start after selecting a port number and press the button ""Start Server""."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   240
      TabIndex        =   4
      Top             =   360
      Width           =   4935
   End
   Begin VB.Label Label1 
      Caption         =   "TCP Server Port number"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   1200
      Width           =   1815
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' Project: TCP Server Example using VB
'
' Description:
'    This application contains a TCP server. The server creates
'    a TCP listening socket and waits for client connections.

'    When a connection is established, TCP server will read data from
'    the connection and echo it back to the TCP client.

'    Note that the server uses blocking sockets to accept connections
'    as well as send and receive data. This means once the server is
'    listening, and the UI will not refresh and the stop button will
'    not be pressed.

Option Explicit

Dim soc As Long
Dim LocalAddr As sockaddr
Dim RemoteAddr As sockaddr
Dim RetMsg As String
Dim ServerOn As Boolean
Dim AcceptSoc As Long
Dim hEvent As Long
Dim dwRc As Long
Dim Selidx As Integer

Private Sub cmdDefaultData_Click()
Dim Count As Integer
Dim strSend(0 To 20) As Byte
Dim i As Long, j As Long
Dim retSend As Long
Dim strLen As Long
Dim strDefault As String
' set default data string, string length is 20
strDefault = "abcdefghij0123456789"
    
    txtSend.Enabled = False
    ' check the count value
    If txtCount.Text = "" Then
        MsgBox " Please enter send default data count. "
        txtSend.Enabled = True
        Exit Sub
    End If
    
    For i = 1 To Len(txtCount.Text)
        If Asc(Mid(txtCount.Text, i, 1)) < Asc(0) Or Asc(Mid(txtCount.Text, i, 1)) > Asc(9) Then
            MsgBox " Invalid Count Number. "
            Exit Sub
        End If
    Next i
    
    Count = txtCount.Text
    strLen = Len(strDefault)
    ' copy default data string to data array
    For i = 1 To strLen
        strSend(i - 1) = AscB(Mid(strDefault, i, 1))
    Next i
    strSend(Len(strDefault)) = 0
    'send data routine
    For i = 1 To Count
        For j = 1 To strLen
            retSend = send(AcceptSoc, strSend(j - 1), 1, 0)
            If retSend = SOCKET_ERROR Then
                MsgBox "Couldn't send data to remote Socket. Error: " & Err.LastDllError
            End If
        Next j
    Next i
    txtSend.Enabled = True

End Sub

' start example program and initial display
Private Sub Form_Load()
    Timer1.Enabled = False
    Timer1.Interval = 10
    If TCPIPStartup Then
        cmdStart.Enabled = True
        cmdStop.Enabled = False
        cmdDefaultData.Enabled = False
        txtPort.Enabled = True
        Timer1.Enabled = False
        Timer1.Interval = 10
        ServerOn = False
        txtCount.Enabled = False
        txtSend.Enabled = False
        txtRecv.Enabled = False
    Else
        MsgBox "Windows Sockets not initialized. Error: " & Err.LastDllError
    End If
    soc = INVALID_SOCKET
    hEvent = WSACreateEvent
End Sub

Private Sub Form_Unload(Cancel As Integer)
    TCPIPShutDown
    If hEvent <> 0 Then WSACloseEvent hEvent
End Sub
' press start button will start TCP server
Private Sub cmdStart_Click()
Dim AddrLen As Long
Dim ret As Long
Dim i, j As Integer
Dim te As Byte

    If txtPort.Text = "" Then
        MsgBox " Please enter host port number. "
        Exit Sub
    End If

    ' create socket for TCP Server
    soc = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)
    If soc = INVALID_SOCKET Then
        MsgBox "Couldn't Create Socket. Error: " & Err.LastDllError
        Exit Sub
    Else
        LocalAddr.sin_family = AF_INET
        LocalAddr.sin_port = htons(CLng(txtPort.Text))
        LocalAddr.sin_addr = 0
    End If
        
    AddrLen = Len(LocalAddr)
    ' bind a socket for server
    ret = bind(soc, LocalAddr, AddrLen)
    If ret = SOCKET_ERROR Then
        MsgBox "Couldn't bind to Socket. Error: " & Err.LastDllError
        closesocket (soc)
        Exit Sub
    Else
        cmdStart.Enabled = False
        cmdStop.Enabled = True
        txtPort.Enabled = False
     
    End If
    'set listen number
    If listen(soc, 1) = SOCKET_ERROR Then
        MsgBox "Couldn't listen() to socket. Error: " & Err.LastDllError
        closesocket (soc)
        Exit Sub
    End If
    'wait client connection and accept connection
    AcceptSoc = accept(soc, RemoteAddr, sockaddr_size)
    If AcceptSoc = INVALID_SOCKET Then
        MsgBox "Couldn't accept a socket connection. Error: " & Err.LastDllError
        closesocket (soc)
        Exit Sub
    End If
    
    txtSend.Enabled = True
    txtCount.Enabled = True
    cmdDefaultData.Enabled = True
    Timer1.Enabled = True

End Sub
' press stop button will stop TCP server and close socket
Private Sub cmdStop_Click()
    txtSend.Text = ""
    txtRecv.Text = ""
    If AcceptSoc <> INVALID_SOCKET Then
        closesocket (AcceptSoc)
        closesocket (soc)
        cmdStart.Enabled = True
        cmdStop.Enabled = False
        txtPort.Enabled = True
        txtSend.Enabled = False
        txtCount.Enabled = False
        cmdDefaultData.Enabled = False
        Timer1.Enabled = False
    End If
    soc = INVALID_SOCKET
    AcceptSoc = INVALID_SOCKET
End Sub
' each time interval will let program enter timer routine.
Private Sub Timer1_Timer()
Dim strRecv As String
Dim retRecv, retSend As Long
    ' let the textbox curses at the end line and lastest position
    txtSend.SelStart = Len(txtSend.Text)
    txtRecv.SelStart = Len(txtRecv.Text)
    
    If soc = INVALID_SOCKET Then
        Debug.Print "Create Socket First"
        Exit Sub
    End If
    
    strRecv = String(1024, 0)
    ' set read socket event
    dwRc = WSAEventSelect(AcceptSoc, hEvent, FD_READ)
    If (dwRc = SOCKET_ERROR) Then
        MsgBox "Failed to select event. Error: " & Err.LastDllError
        Exit Sub
    End If
    
    ' wait for reading event
    dwRc = WSAWaitForMultipleEvents(1, hEvent, False, 0, False)
       
    Select Case dwRc
    Case WSA_WAIT_TIMEOUT
        Debug.Print "Recv timed out"
        
    Case WSA_WAIT_EVENT_0
        Dim NetworkEvents As WSANETWORKEVENTS
        Dim dwRet As Long
        NetworkEvents.lNetWorkEvents = 0
        dwRet = WSAEnumNetworkEvents(AcceptSoc, hEvent, NetworkEvents)
        If (dwRet = SOCKET_ERROR) Then
            MsgBox "WSAEnumNetworkEvents failed to select event. Error: " & Err.LastDllError
        Else
        'recv data from socket
            If (FD_READ And NetworkEvents.lNetWorkEvents) Then
                retRecv = recv(AcceptSoc, ByVal strRecv, Len(strRecv), 0)
                If retRecv = SOCKET_ERROR Then
                    MsgBox "Couldn't recieve data from remote Socket. Error: " & Err.LastDllError
                    closesocket (AcceptSoc)
                    closesocket (soc)
                    cmdStart.Enabled = True
                    cmdStop.Enabled = False
                    txtPort.Enabled = True
                    Timer1.Enabled = False
                    txtSend.Enabled = False
                    txtCount.Enabled = False
                    cmdDefaultData.Enabled = False
                    Exit Sub
                 ElseIf retRecv = 0 Then
                    MsgBox "The connection has been interrupted. Error: " & Err.LastDllError
                    closesocket (AcceptSoc)
                    closesocket (soc)
                    cmdStart.Enabled = True
                    cmdStop.Enabled = False
                    txtPort.Enabled = True
                    Timer1.Enabled = False
                    txtSend.Enabled = False
                    txtCount.Enabled = False
                    cmdDefaultData.Enabled = False
                                        
                    Exit Sub
                Else
                'display received data in textbox
                    txtRecv.Text = txtRecv.Text & Left(strRecv, retRecv)
                End If
            End If
        End If
        
    
    Case WSA_WAIT_FAILED
        MsgBox "WSAWaitForMultipleEvents failed. Error: " & Err.LastDllError
    Case Else
        MsgBox "Unexpected WSAWaitForMultipleEvents return. Error: " & Err.LastDllError
    End Select
    
    dwRc = WSAEventSelect(soc, hEvent, 0)
    If (dwRc = SOCKET_ERROR) Then
        MsgBox "Failed to select event. Error: " & Err.LastDllError
        Exit Sub
    End If
End Sub

Private Sub txtCount_Change()
Dim cnt As Byte

    If txtCount.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtCount.SelStart
    End If
    If Len(txtCount.Text) > 0 Then
        cnt = Asc(Mid(txtCount.Text, txtCount.SelStart, 1))
        If cnt < Asc(0) Or cnt > Asc(9) Then
            txtCount.Text = Left(txtCount.Text, txtCount.SelStart - 1) & Right(txtCount.Text, Len(txtCount.Text) - txtCount.SelStart)
            txtCount.SelStart = Selidx - 1
        End If
    End If

End Sub

Private Sub txtPort_Change()
Dim port As Byte

    If txtPort.SelStart = 0 Then
        Exit Sub
    Else
        Selidx = txtPort.SelStart
    End If
    If Len(txtPort.Text) > 0 Then
            port = Asc(Mid(txtPort.Text, txtPort.SelStart, 1))
            If port < Asc(0) Or port > Asc(9) Then
                txtPort.Text = Left(txtPort.Text, txtPort.SelStart - 1) & Right(txtPort.Text, Len(txtPort.Text) - txtPort.SelStart)
                txtPort.SelStart = Selidx - 1
            End If
    End If
End Sub

Private Sub txtSend_Change()
Dim strSend As String
Dim chSend(0 To 1) As Byte
Dim retSend As Long
    ' catch the part of change in textbox
    If Len(txtSend.Text) > 0 Then
        strSend = txtSend.Text
        chSend(0) = Asc(Mid(strSend, Len(strSend), 1))
    Else
        Exit Sub
    End If
    ' send the data of change to socket
    retSend = send(AcceptSoc, chSend(0), UBound(chSend), 0)
    If retSend = SOCKET_ERROR Then
        MsgBox "Couldn't send data to remote Socket. Error: " & Err.LastDllError
    End If
End Sub
